/*
	fnxstr.c     	10/01/86

	% xstring_funcs

	String editing functions.
	Supports insert mode (with big cursor).
	The field variable should be a char *.

	This is an "extended" version of string_funcs that accepts
	characters beyond the normal printable range (i.e. beyond
	character 127)  This is useful for European character sets.

	C-scape 3.2
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 4/06/88 jmd 	added call to sed_DoSpecial
	 9/15/88 jmd 	removed vid_Cursor calls
	 9/17/88 jmd 	added std_ funcs
	10/14/88 jdc	added var_size element to field_funcs_struct

	 6/07/89 jmd	added test for mouse code (later removed)
	 3/28/90 jmd	ansi-fied
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "cscape.h"
#include "fnfunc.h"			/* for field functions */
#include "scancode.h"

OSTATIC sfilter_func (xstring_filter);

OGLOBAL field_funcs_struct xstring_funcs = {
	stdBigCur_fenter,
	string_fexit,
	xstring_fkey,
	string_senter,
	string_sexit,
	VAR_STRING
};

void xstring_fkey(sed_type sed)
/*
	Hands its work to StrCommon_fkey (fnstrcom.c)
	Passes a filter function (below) to decide which
	characters can be typed in.
*/
{
	StrCommon_fkey(sed, xstring_filter);
}

static boolean xstring_filter(int key)
/*
	Filter function for xstring_funcs
	for use with StrCommon_fkey
*/
{
	return(isprint(key) || ((unsigned char) (key)) > 127);
}
